	list p=16f877a
	#include <p16f877a.inc>
	radix dec
; Compiled with: PIC Simulator IDE v6.73
; Microcontroller model: PIC16F877A
; Clock frequency: 16.0 MHz
; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0003
	ORG 0x0004
	RETFIE
L0003:
; 1: Define ADC_CLOCK = 3 'default value is 3
; 2: Define ADC_SAMPLEUS = 20 'default value is 20
; 3: Define LCD_BITS = 8 'allowed values are 4 and 8 - the number of data interface lines
; 4: Define LCD_DREG = PORTD
; 5: Define LCD_DBIT = 0 '0 or 4 for 4-bit interface, ignored for 8-bit interface
; 6: Define LCD_RSREG = PORTC
; 7: Define LCD_RSBIT = 0
; 8: Define LCD_EREG = PORTC
; 9: Define LCD_EBIT = 1
; 10: Define LCD_RWREG = 0 'set to 0 if not used, 0 is default
; 11: Define LCD_RWBIT = 0 'set to 0 if not used, 0 is default
; 12: Define LCD_COMMANDUS = 2000 'REM'' 'delay after LCDCMDOUT, default value is 5000
; 13: Define LCD_DATAUS = 50 'REM' 'delay after LCDOUT, default value is 100
; 14: Define LCD_INITMS = 2 'REM''' 'delay used by LCDINIT, default value is 100
; 15:  'the last three Define directives set the values suitable for simulation; they should be omitted for a real device
; 16: Dim an0 As Word
;       The address of 'an0' is 0x2C
	an0 EQU 0x2C
; 17: Dim abc As Byte
;       The address of 'abc' is 0x2E
	abc EQU 0x2E
; 18: Dim suman0 As Word
;       The address of 'suman0' is 0x2F
	suman0 EQU 0x2F
; 19: Dim lit As Byte
;       The address of 'lit' is 0x31
	lit EQU 0x31
; 20: Dim dec As Byte
;       The address of 'dec' is 0x32
	dec EQU 0x32
; 21: TRISA = 0xff 'set all PORTA pins as inputs
	BSF STATUS,RP0
	MOVLW 0xFF
	MOVWF 0x05
; 22: ADCON1 = 0 'set all PORTA pins as analog inputs
	CLRF 0x1F
	BCF STATUS,RP0
; 23: Lcdinit 0 'initialize LCD module; cursor is blinking
	BCF 0x07,1
	BCF 0x07,0
	BSF STATUS,RP0
	BCF 0x07,1
	BCF 0x07,0
	CLRF 0x08
	BCF STATUS,RP0
	MOVLW 0x02
	MOVWF R0L
	MOVLW 0x00
	MOVWF R0H
	CALL W001
	MOVLW 0x33
	CALL LC02
	MOVLW 0x33
	CALL LC02
	MOVLW 0x33
	CALL LC02
	MOVLW 0x38
	CALL LC02
	MOVLW 0x0C
	CALL LC02
	MOVLW 0x01
	CALL LC02
; 24: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 25: Lcdout "****************"
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
; 26: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 27: Lcdout "****************"
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
; 28: WaitMs 2000
	MOVLW 0xD0
	MOVWF R0L
	MOVLW 0x07
	MOVWF R0H
	CALL W001
; 29: 
; 30: loop: 
L0001:
; 31: abc = 0
	CLRF 0x2E
; 32: suman0 = 0
	CLRF 0x2F
	CLRF 0x30
; 33: avrg: 
L0002:
; 34: Adcin 0, an0
	BSF STATUS,RP0
	BSF ADCON1,ADFM
	BCF ADCON1,ADCS2
	MOVLW 0x00
	BCF STATUS,RP0
	MOVWF R0L
	CALL A001
	BSF STATUS,RP0
	MOVF ADRESL,W
	BCF STATUS,RP0
	MOVWF 0x2C
	MOVF ADRESH,W
	MOVWF 0x2D
; 35: suman0 = suman0 + an0
	MOVF 0x2F,W
	ADDWF 0x2C,W
	MOVWF 0x2F
	MOVF 0x30,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x2D,W
	MOVWF 0x30
; 36: abc = abc + 1
	MOVF 0x2E,W
	ADDLW 0x01
	MOVWF 0x2E
; 37: If abc < 10 Then Goto avrg
	MOVLW 0x0A
	SUBWF 0x2E,W
	BTFSC STATUS,C
	GOTO L0004
	GOTO L0002
L0004:	MOVLW 0x1F
	ANDWF STATUS,F
; 38: an0 = suman0 / 10
	MOVF 0x2F,W
	MOVWF R0L
	MOVF 0x30,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x2C
	MOVF R0H,W
	MOVWF 0x2D
; 39: 
; 40: If an0 < 102 Then
	MOVF 0x2C,W
	MOVWF R0L
	MOVF 0x2D,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x66
	CALL C004
	BTFSS STATUS,Z
	GOTO L0005
; 41: an0 = 102
	MOVLW 0x66
	MOVWF 0x2C
	CLRF 0x2D
; 42: Endif
L0005:	MOVLW 0x1F
	ANDWF STATUS,F
; 43: 
; 44: If an0 >= 757 Then
	MOVF 0x2C,W
	MOVWF R0L
	MOVF 0x2D,W
	MOVWF R0H
	MOVLW 0x02
	MOVWF R1H
	MOVLW 0xF5
	CALL C005
	BTFSS STATUS,Z
	GOTO L0006
; 45: an0 = 757
	MOVLW 0xF5
	MOVWF 0x2C
	MOVLW 0x02
	MOVWF 0x2D
; 46: Endif
L0006:	MOVLW 0x1F
	ANDWF STATUS,F
; 47: 
; 48: an0 = an0 - 102
	MOVLW 0x66
	SUBWF 0x2C,W
	MOVWF 0x2C
	MOVLW 0x00
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF 0x2D,W
	MOVWF 0x2D
; 49: an0 = an0 * 100
	MOVF 0x2C,W
	MOVWF R3L
	MOVF 0x2D,W
	MOVWF R3H
	MOVLW 0x64
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVWF 0x2C
	MOVF R2H,W
	MOVWF 0x2D
; 50: an0 = an0 / 327
	MOVF 0x2C,W
	MOVWF R0L
	MOVF 0x2D,W
	MOVWF R0H
	MOVLW 0x47
	MOVWF R1L
	MOVLW 0x01
	MOVWF R1H
	CALL D001
	MOVWF 0x2C
	MOVF R0H,W
	MOVWF 0x2D
; 51: lit = an0 / 10
;       The address of 'oshonsoft_temp_1' is 0x33
	oshonsoft_temp_1 EQU 0x33
	MOVF 0x2C,W
	MOVWF R0L
	MOVF 0x2D,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x33
	MOVF R0H,W
	MOVWF 0x34
	MOVF 0x33,W
	MOVWF 0x31
; 52: dec = an0 Mod 10
	MOVF 0x2C,W
	MOVWF R0L
	MOVF 0x2D,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x33
	MOVF R2H,W
	MOVWF 0x34
	MOVF 0x33,W
	MOVWF 0x32
; 53: 
; 54: Lcdcmdout LcdClear 'clear LCD display
	MOVLW 0x01
	CALL LC02
; 55: If lit >= 5 Then
	MOVLW 0x05
	SUBWF 0x31,W
	BTFSS STATUS,C
	GOTO L0007
; 56: Lcdout "Fuel Level" 'text for the line 1
	MOVLW 0x46
	CALL LC01
	MOVLW 0x75
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x76
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x6C
	CALL LC01
; 57: Endif
L0007:	MOVLW 0x1F
	ANDWF STATUS,F
; 58: 
; 59: If lit < 5 Then
	MOVLW 0x05
	SUBWF 0x31,W
	BTFSC STATUS,C
	GOTO L0008
; 60: Lcdout "LOW FUEL: <25%"
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x4F
	CALL LC01
	MOVLW 0x57
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x46
	CALL LC01
	MOVLW 0x55
	CALL LC01
	MOVLW 0x45
	CALL LC01
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x3C
	CALL LC01
	MOVLW 0x32
	CALL LC01
	MOVLW 0x35
	CALL LC01
	MOVLW 0x25
	CALL LC01
; 61: Endif
L0008:	MOVLW 0x1F
	ANDWF STATUS,F
; 62: 
; 63: If lit <= 5 And lit > 2 Then
	MOVF 0x31,W
	SUBLW 0x05
	BTFSS STATUS,C
	GOTO L0009
	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x31,W
	SUBLW 0x02
	BTFSC STATUS,C
	GOTO L0009
; 64: Lcdout "Low Fuel: <25%"
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x77
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x46
	CALL LC01
	MOVLW 0x75
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x3C
	CALL LC01
	MOVLW 0x32
	CALL LC01
	MOVLW 0x35
	CALL LC01
	MOVLW 0x25
	CALL LC01
; 65: Endif
L0009:	MOVLW 0x1F
	ANDWF STATUS,F
; 66: 
; 67:  'If lit >= 5 And lit < 10 Then
; 68:  'Lcdout "Fuel Level: <50%"
; 69:  'Endif
; 70: 
; 71: 
; 72: Lcdcmdout LcdLine2Home 'set cursor at the beginning of line 2
	MOVLW 0xC0
	CALL LC02
; 73: Lcdout "Volume: ",
	MOVLW 0x56
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x75
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 74: If lit < 10 Then Lcdout " ",
	MOVLW 0x0A
	SUBWF 0x31,W
	BTFSC STATUS,C
	GOTO L0010
	MOVLW 0x20
	CALL LC01
L0010:	MOVLW 0x1F
	ANDWF STATUS,F
; 75: Lcdout #lit, ".", #dec, " L" 'formatted text for line 2
	MOVF 0x31,W
	MOVWF R2L
	CLRF R2H
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVF 0x32,W
	MOVWF R2L
	CLRF R2H
	CALL LC21
	MOVLW 0x20
	CALL LC01
	MOVLW 0x4C
	CALL LC01
; 76: WaitMs 150 'larger value should be used in real device
	MOVLW 0x96
	MOVWF R0L
	CLRF R0H
	CALL W001
; 77: Goto loop 'loop forever
	GOTO L0001
; End of program
L0011:	GOTO L0011
; Multiplication Routine
M001:	MOVLW 0x10
	MOVWF R4L
	CLRF R0H
	CLRF R0L
M002:	RRF R3H,F
	RRF R3L,F
	BTFSS STATUS,C
	GOTO M003
	MOVF R1L,W
	ADDWF R0L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R0H,F
M003:	RRF R0H,F
	RRF R0L,F
	RRF R2H,F
	RRF R2L,F
	DECFSZ R4L,F
	GOTO M002
	MOVF R2L,W
	RETURN
; Division Routine
D001:	MOVLW 0x10
	MOVWF R3L
	CLRF R2H
	CLRF R2L
D002:	RLF R0H,W
	RLF R2L,F
	RLF R2H,F
	MOVF R1L,W
	SUBWF R2L,F
	MOVF R1H,W
	BTFSS STATUS,C
	INCFSZ R1H,W
	SUBWF R2H,F
	BTFSC STATUS,C
	GOTO D003
	MOVF R1L,W
	ADDWF R2L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R2H,F
	BCF STATUS,C
D003:	RLF R0L,F
	RLF R0H,F
	DECFSZ R3L,F
	GOTO D002
	MOVF R0L,W
	RETURN
; Comparison Routine
C001:	MOVWF R1L
	MOVLW 0x05
	GOTO C007
C002:	MOVWF R1L
	MOVLW 0x02
	GOTO C007
C003:	MOVWF R1L
	MOVLW 0x06
	GOTO C007
C004:	MOVWF R1L
	MOVLW 0x03
	GOTO C007
C005:	MOVWF R1L
	MOVLW 0x04
	GOTO C007
C006:	MOVWF R1L
	MOVLW 0x01
	GOTO C007
C007:	MOVWF R4L
	MOVF R1H,W
	SUBWF R0H,W
	BTFSS STATUS,Z
	GOTO C008
	MOVF R1L,W
	SUBWF R0L,W
C008:	MOVLW 0x04
	BTFSC STATUS,C
	MOVLW 0x01
	BTFSC STATUS,Z
	MOVLW 0x02
	ANDWF R4L,W
	BTFSS STATUS,Z
	MOVLW 0xFF
	RETURN
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x4E
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; Waitus Routine - Byte Argument
X001:	MOVLW 0x03
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002
X002:	MOVLW 0x02
	SUBWF R4L,F
	NOP
	NOP
	BTFSS STATUS,C
	RETURN
	GOTO X002
; Waitus Routine - Word Argument
Y001:	MOVLW 0x04
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
Y002:	MOVLW 0x03
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	NOP
	NOP
	BTFSS STATUS,C
	RETURN
	GOTO Y002
; Adcin Routine
A001:	RLF R0L,F
	RLF R0L,F
	RLF R0L,F
	MOVLW 0x38
	ANDWF R0L,F
	MOVLW 0xC1
	IORWF R0L,W
	MOVWF ADCON0
	MOVLW 0x14
	MOVWF R4L
	CALL X001
	BSF ADCON0,GO
A002:	BTFSC ADCON0,GO
	GOTO A002
	BCF PIR1,ADIF
	BCF ADCON0,ADON
	RETURN
; Lcdout Routine
LC01:	BSF 0x07,0
	MOVWF 0x08
	CALL LCX1
	MOVLW 0x32
	MOVWF R4L
	CALL X001
	RETURN
LCX1:	BSF 0x07,1
	NOP
	NOP
	NOP
	NOP
	BCF 0x07,1
	NOP
	NOP
	NOP
	NOP
	RETURN
; Lcdcmdout Routine
LC02:	BCF 0x07,0
	MOVWF 0x08
	CALL LCX1
	MOVLW 0xD0
	MOVWF R4L
	MOVLW 0x07
	MOVWF R4H
	CALL Y001
	RETURN
; Lcdout Decimal Conversion Routine
LC21:	BSF R3H,7
	MOVLW 0x27
	MOVWF R1H
	MOVLW 0x10
	CALL LC22
	MOVLW 0x03
	MOVWF R1H
	MOVLW 0xE8
	CALL LC22
	CLRF R1H
	MOVLW 0x64
	CALL LC22
	CLRF R1H
	MOVLW 0x0A
	CALL LC22
	MOVF R2L,W
	GOTO LC23
LC22:	MOVWF R1L
	MOVF R2H,W
	MOVWF R0H
	MOVF R2L,W
	MOVWF R0L
	CALL D001
	MOVF R0L,W
	BTFSS STATUS,Z
	BCF R3H,7
	BTFSC R3H,7
	RETURN
LC23:	ADDLW 0x30
	CALL LC01
	RETURN
; End of listing
	END
